﻿using System.Web.Mvc;
using PopEmail.Models;
using System.Collections.Generic;
using Aspose.Network.Pop3;
using Aspose.Network.Mail;
using System.IO;

namespace PopEmail.Controllers
{
    public class MailController : Controller
    {
        public ActionResult GetMail()
        {
            return View();
        }
        [HttpPost]
        public ActionResult Pop()
        {
            List<Mail> ListMail = new List<Mail>();//存储下载的邮件信息

            //建立连接  Pop3Client(邮件POP，端口，用户名，密码)
            Pop3Client Pop3 = new Pop3Client(Request.Form["pop"], 110, Request.Form["user"], Request.Form["pass"]);
            Pop3.Connect(true);//连接并且登录
            int MessageCount = Pop3.GetMessageCount();//获取目标邮箱所有邮件数量

            //循环获取单个邮件信息 
            for (int i = 1; i <= MessageCount; i++)
            {
                Mail ModelMail = new Mail();//单条邮件实体
                //获取单条邮件
                MailMessage MailMsg = Pop3.FetchMessage(i);
                string MessageID = Pop3.GetMessageUniqueId(i);//邮件唯一ID
                ModelMail.Date = MailMsg.Date;//发送时间
                ModelMail.Subject = MailMsg.Subject;//主题
                ModelMail.Body = MailMsg.HtmlBody;//内容 
                for (int j = 0; j < MailMsg.To.Count; j++)//收件人
                {
                    ModelMail.To += MailMsg.To[j].Address + ";";
                    ModelMail.ToName += MailMsg.To[j].DisplayName + "&lt;" + MailMsg.To[j].Address + ">";
                }
                for (int j = 0; j < MailMsg.CC.Count; j++)//抄送
                {
                    ModelMail.CC += MailMsg.CC[j].Address + ";";
                    ModelMail.CCName += MailMsg.CC[j].DisplayName + "&lt;" + MailMsg.CC[j].Address + ">";
                }
                for (int j = 0; j < MailMsg.From.Count; j++)//发送人  
                {
                    ModelMail.From += MailMsg.From[j].Address + ";";
                    ModelMail.FromName += MailMsg.From[j].DisplayName + "&lt;" + MailMsg.From[j].Address + ">";
                }
                AttachmentCollection Att = MailMsg.Attachments;//获取附件
                string path = string.Empty;
                foreach (var list in Att)
                {
                    path = Server.MapPath("/Att/" + MessageID + "/");
                    if (!System.IO.Directory.Exists(path))
                    {
                        Directory.CreateDirectory(path);
                    }
                    list.Save(path + list.Name);
                    ModelMail.Att += list.Name + ";";
                }
                LinkedResourceCollection MailLink = MailMsg.LinkedResources;//内嵌附件
                foreach (var list in MailLink)
                {
                    if (string.IsNullOrEmpty(list.Name))
                        continue;
                    string ContentId = list.ContentId;
                    path = Server.MapPath("/Att/" + MessageID + "/");
                    if (!System.IO.Directory.Exists(path))
                    {
                        Directory.CreateDirectory(path);
                    }
                    list.Save(path + list.Name);
                    ModelMail.Body = ModelMail.Body.Replace("cid:" + ContentId, "/Att/" + MessageID + "/" + list.Name);//替换内容中的内嵌附件
                }
                ListMail.Add(ModelMail);
                //删除服务器上的原始邮件
                //Pop3.DeleteMessage(i);
            }
            //断开链接
            Pop3.Disconnect();
            return View(ListMail);
        }
    }
}
